diff -ruNp linux-2.6.26.1/arch/x86/SYSCALLS.x86_64_ia32 linux-2.6.26.1-cher1/arch/x86/SYSCALLS.x86_64_ia32
--- linux-2.6.26.1/arch/x86/SYSCALLS.x86_64_ia32	1970-01-01 03:00:00.000000000 +0300
+++ linux-2.6.26.1-cher1/arch/x86/SYSCALLS.x86_64_ia32	2008-08-05 13:44:37.000000000 +0400
@@ -0,0 +1,334 @@
+sys_exit                        kernel/exit.c                           OK
+stub32_fork                     arch/x86/ia32/ia32entry.S               CAP
+sys_read                        fs/read_write.c                         OK
+sys_write                       fs/read_write.c                         OK
+compat_sys_open                 fs/compat.c                             CAP
+sys_close                       fs/open.c                               OK
+sys32_waitpid                   arch/x86/ia32/sys_ia32.c                CAP
+sys_creat                       fs/open.c                               CAP
+sys_link                        fs/namei.c                              CAP
+sys_unlink                      fs/namei.c                              CAP
+stub32_execve                   arch/x86/ia32/ia32entry.S               CAP
+sys_chdir                       fs/open.c                               CAP
+compat_sys_time                                                         OK
+sys_mknod                       fs/namei.c                              CAP
+sys_chmod                       fs/open.c                               CAP
+sys_lchown16                    kernel/uid16.c                          CAP
+quiet_ni_syscall                                                        ---
+sys_stat                        fs/stat.c                               CAP
+sys32_lseek                     arch/x86/ia32/sys_ia32.c                CAP
+sys_getpid                                                              OK
+compat_sys_mount                fs/compat.c                             CAP
+sys_oldumount                   fs/namespace.c                          CAP
+sys_setuid16                    kernel/uid16.c                          CAP
+sys_getuid16                                                            OK
+compat_sys_stime                kernel/compat.c                         CAP
+compat_sys_ptrace               kernel/ptrace.c                         CAP
+sys_alarm                       kernel/timer.c                          OK
+sys_fstat                       fs/stat.c                               CAP
+sys_pause                       kernel/signal.c                         CAP
+compat_sys_utime                fs/compat.c                             CAP
+quiet_ni_syscall                                                        ---
+quiet_ni_syscall                                                        ---
+sys_access                      fs/open.c                               CAP
+sys_nice	                kernel/sched.c                          CAP
+quiet_ni_syscall                                                        ---
+sys_sync                        fs/sync.c                               CAP+
+sys32_kill                      arch/x86/ia32/sys_ia32.c                CAP+
+sys_rename                      fs/namei.c                              CAP+
+sys_mkdir                       fs/namei.c                              CAP+
+sys_rmdir                       fs/namei.c                              CAP+
+sys_dup                         fs/fcntl.c                              CAP?
+sys32_pipe                      arch/x86/ia32/sys_ia32.c                CAP
+compat_sys_times                                                        OK
+quiet_ni_syscall                                                        ---
+sys_brk                                                                 OK
+sys_setgid16                    kernel/uid16.c                          CAP+
+sys_getgid16                                                            OK
+sys_signal                                                              OK
+sys_geteuid16                                                           OK
+sys_getegid16                                                           OK
+sys_acct                        kernel/acct.c                           CAP+
+sys_umount                      fs/namespace.c                          CAP
+quiet_ni_syscall                                                        ---
+compat_sys_ioctl                fs/compat_ioctl.c                       CAP
+compat_sys_fcntl64              fs/compat.c                             CAP
+quiet_ni_syscall                                                        ---
+sys_setpgid                     kernel/sys.c                            CAP
+quiet_ni_syscall                                                        ---
+sys32_olduname                                                          OK
+sys_umask                       kernel/sys.c                            CAP
+sys_chroot                      fs/open.c                               CAP+
+sys32_ustat                     arch/x86/ia32/sys_ia32.c                CAP
+sys_dup2                        fs/fcntl.c                              CAP?
+sys_getppid                                                             OK
+sys_getpgrp                                                             OK
+sys_setsid                      kernel/sys.c                            CAP+
+sys32_sigaction                                                         OK
+sys_sgetmask                                                            OK
+sys_ssetmask                    kernel/signal.c                         CAP
+sys_setreuid16                  kernel/uid16.c                          CAP+
+sys_setregid16                  kernel/uid16.c                          CAP+
+stub32_sigsuspend               arch/x86/ia32/ia32entry.S               CAP
+compat_sys_sigpending           kernel/compat.c                         CAP
+sys_sethostname                 kernel/sys.c                            CAP+
+compat_sys_setrlimit            kernel/compat.c                         CAP
+compat_sys_old_getrlimit                                                OK
+compat_sys_getrusage                                                    OK
+sys32_gettimeofday                                                      OK
+sys32_settimeofday              arch/x86/ia32/sys_ia32.c                CAP+
+sys_getgroups16                                                         OK
+sys_setgroups16                 kernel/uid16.c                          CAP+
+sys32_old_select                                                        OK
+sys_symlink                     fs/namei.c                              CAP+
+sys_lstat                       fs/stat.c                               CAP
+sys_readlink                    fs/stat.c                               CAP
+sys_uselib                      fs/exec.c                               CAP
+sys_swapon                      mm/swapfile.c                           CAP+
+sys_reboot                      kernel/sys.c                            CAP+
+compat_sys_old_readdir          fs/compat.c                             CAP
+sys32_mmap                                                              OK
+sys_munmap                                                              OK
+sys_truncate                    fs/open.c                               CAP
+sys_ftruncate                   fs/open.c                               CAP
+sys_fchmod                      fs/open.c                               CAP+
+sys_fchown16                    kernel/uid16.c                          CAP+
+sys_getpriority                 kernel/sys.c                            CAP
+sys_setpriority                 kernel/sys.c                            CAP
+quiet_ni_syscall                                                        ---
+compat_sys_statfs               fs/compat.c                             CAP
+compat_sys_fstatfs              fs/compat.c                             CAP
+sys_ioperm                      arch/x86/kernel/ioport.c                CAP+
+compat_sys_socketcall           net/compat.c                            CAP+
+sys_syslog                      kernel/printk.c                         CAP
+compat_sys_setitimer                                                    OK
+compat_sys_getitimer                                                    OK
+compat_sys_newstat              fs/compat.c                             CAP
+compat_sys_newlstat             fs/compat.c                             CAP
+compat_sys_newfstat             fs/compat.c                             CAP
+sys32_uname                                                             OK
+stub32_iopl                     arch/x86/ia32/ia32entry.S               CAP+
+sys_vhangup                     fs/open.c                               CAP+
+quiet_ni_syscall                                                        ---
+sys32_vm86_warning              arch/x86/ia32/sys_ia32.c                CAP
+compat_sys_wait4                kernel/compat.c                         CAP
+sys_swapoff                     mm/swapfile.c                           CAP
+compat_sys_sysinfo              kernel/compat.c                         CAP
+sys32_ipc                       arch/x86/ia32/ipc32.c                   CAP+
+sys_fsync                       fs/sync.c                               CAP+
+stub32_sigreturn                                                        OK
+stub32_clone                    arch/x86/ia32/ia32entry.S               CAP+
+sys_setdomainname               kernel/sys.c                            CAP+
+sys_uname                                                               OK
+sys_modify_ldt                  arch/x86/kernel/ldt.c                   CAP+
+compat_sys_adjtimex             kernel/compat.c                         CAP+
+sys32_mprotect                  arch/x86/ia32/sys_ia32.c                CAP+
+compat_sys_sigprocmask          kernel/compat.c                         CAP
+quiet_ni_syscall                                                        ---
+sys_init_module                 kernel/module.c                         CAP+
+sys_delete_module               kernel/module.c                         CAP+
+quiet_ni_syscall                                                        ---
+sys32_quotactl                  kernel/quota.c                          CAP+
+sys_getpgid                     kernel/sys.c                            CAP
+sys_fchdir                      fs/open.c                               CAP
+quiet_ni_syscall                                                        ---
+sys_sysfs                       fs/filesystems.c                        CAP+
+sys_personality                 kernel/exec_domain.c                    CAP
+quiet_ni_syscall                                                        ---
+sys_setfsuid16                  kernel/uid16.c                          CAP+
+sys_setfsgid16                  kernel/uid16.c                          CAP+
+sys_llseek                      fs/read_write.c                         CAP
+compat_sys_getdents             fs/compat.c                             CAP
+compat_sys_select                                                       OK
+sys_flock                       fs/locks.c                              CAP+
+sys_msync                                                               OK
+compat_sys_readv                                                        OK
+compat_sys_writev                                                       OK
+sys_getsid                      kernel/sys.c                            CAP
+sys_fdatasync                   fs/sync.c                               CAP+
+sys32_sysctl                    arch/x86/ia32/sys_ia32.c                CAP+
+sys_mlock                       mm/mlock.c                              CAP+
+sys_munlock                     mm/mlock.c                              CAP+
+sys_mlockall                    mm/mlock.c                              CAP+
+sys_munlockall                  mm/mlock.c                              CAP+
+sys_sched_setparam              kernel/sched.c                          CAP
+sys_sched_getparam              kernel/sched.c                          CAP
+sys_sched_setscheduler          kernel/sched.c                          CAP
+sys_sched_getscheduler          kernel/sched.c                          CAP
+sys_sched_yield                                                         OK
+sys_sched_get_priority_max                                              OK
+sys_sched_get_priority_min                                              OK
+sys32_sched_rr_get_interval                                             OK
+compat_sys_nanosleep                                                    OK?
+sys_mremap                                                              OK?
+sys_setresuid16                 kernel/uid16.c                          CAP+
+sys_getresuid16                                                         OK?
+sys32_vm86_warning              arch/x86/ia32/sys_ia32.c                CAP+
+quiet_ni_syscall                                                        ---
+sys_poll                                                                OK
+compat_sys_nfsservctl           fs/compat.c                             CAP+
+sys_setresgid16                 kernel/uid16.c                          CAP+
+sys_getresgid16                                                         OK
+sys_prctl                       kernel/sys.c                            CAP
+stub32_rt_sigreturn                                                     OK
+sys32_rt_sigaction                                                      OK
+sys32_rt_sigprocmask            arch/x86/ia32/sys_ia32.c                CAP
+sys32_rt_sigpending             arch/x86/ia32/sys_ia32.c                CAP
+compat_sys_rt_sigtimedwait      kernel/compat.c                         CAP
+sys32_rt_sigqueueinfo           arch/x86/ia32/sys_ia32.c                CAP
+stub32_rt_sigsuspend            arch/x86/ia32/ia32entry.S               CAP
+sys32_pread                     arch/x86/ia32/sys_ia32.c                CAP
+sys32_pwrite                    arch/x86/ia32/sys_ia32.c                CAP
+sys_chown16                     kernel/uid16.c                          CAP+
+sys_getcwd                      fs/dcache.c                             CAP
+sys_capget                      kernel/capability.c                     CAP
+sys_capset                      kernel/capability.c                     CAP+
+stub32_sigaltstack                                                      OK
+sys32_sendfile                  arch/x86/ia32/sys_ia32.c                CAP
+quiet_ni_syscall                                                        ---
+quiet_ni_syscall                                                        ---
+stub32_vfork                    arch/x86/ia32/ia32entry.S               CAP+
+compat_sys_getrlimit                                                    OK
+sys32_mmap2                                                             OK
+sys32_truncate64                arch/x86/ia32/sys_ia32.c                CAP
+sys32_ftruncate64               arch/x86/ia32/sys_ia32.c                CAP
+sys32_stat64                    arch/x86/ia32/sys_ia32.c                CAP
+sys32_lstat64                   arch/x86/ia32/sys_ia32.c                CAP
+sys32_fstat64                   arch/x86/ia32/sys_ia32.c                CAP
+sys_lchown                      fs/open.c                               CAP
+sys_getuid                                                              OK
+sys_getgid                                                              OK
+sys_geteuid                                                             OK
+sys_getegid                                                             OK
+sys_setreuid                    kernel/sys.c                            CAP+
+sys_setregid                    kernel/sys.c                            CAP+
+sys_getgroups                                                           OK
+sys_setgroups                   kernel/sys.c                            CAP+
+sys_fchown                      fs/open.c                               CAP+
+sys_setresuid                   kernel/sys.c                            CAP+
+sys_getresuid                                                           OK
+sys_setresgid                   kernel/sys.c                            CAP+
+sys_getresgid                                                           OK
+sys_chown                       fs/open.c                               CAP+
+sys_setuid                      kernel/sys.c                            CAP
+sys_setgid                      kernel/sys.c                            CAP+
+sys_setfsuid                    kernel/sys.c                            CAP+
+sys_setfsgid                    kernel/sys.c                            CAP+
+sys_pivot_root                  fs/namespace.c                          CAP+
+sys_mincore                     mm/mincore.c                            CAP
+sys_madvise                     mm/madvise.c                            CAP
+compat_sys_getdents64           fs/compat.c                             CAP
+compat_sys_fcntl64              fs/compat.c                             CAP
+quiet_ni_syscall                                                        ---
+quiet_ni_syscall                                                        ---
+sys_gettid	                                                        OK
+sys32_readahead                 arch/x86/ia32/sys_ia32.c                CAP
+sys_setxattr                    fs/xattr.c                              CAP+
+sys_lsetxattr                   fs/xattr.c                              CAP+
+sys_fsetxattr                   fs/xattr.c                              CAP+
+sys_getxattr                    fs/xattr.c                              CAP+
+sys_lgetxattr                   fs/xattr.c                              CAP+
+sys_fgetxattr                   fs/xattr.c                              CAP+
+sys_listxattr                   fs/xattr.c                              CAP+
+sys_llistxattr                  fs/xattr.c                              CAP+
+sys_flistxattr                  fs/xattr.c                              CAP+
+sys_removexattr                 fs/xattr.c                              CAP+
+sys_lremovexattr                fs/xattr.c                              CAP+
+sys_fremovexattr                fs/xattr.c                              CAP+
+sys_tkill                       kernel/signal.c                         CAP
+sys_sendfile64                  fs/read_write.c                         CAP
+compat_sys_futex                                                        OK
+compat_sys_sched_setaffinity    kernel/compat.c                         CAP
+compat_sys_sched_getaffinity    kernel/compat.c                         CAP
+sys_set_thread_area                                                     OK
+sys_get_thread_area                                                     OK
+compat_sys_io_setup             fs/compat.c                             CAP
+sys_io_destroy                  fs/aio.c                                CAP
+compat_sys_io_getevents         fs/compat.c                             CAP
+compat_sys_io_submit            fs/compat.c                             CAP
+sys_io_cancel                   fs/aio.c                                CAP
+sys32_fadvise64                 arch/x86/ia32/sys_ia32.c                CAP
+quiet_ni_syscall                                                        ---
+sys_exit_group                                                          OK
+sys32_lookup_dcookie            arch/x86/ia32/sys_ia32.c                CAP
+sys_epoll_create                fs/eventpoll.c                          CAP
+sys_epoll_ctl                   fs/eventpoll.c                          CAP
+sys_epoll_wait                  fs/eventpoll.c                          CAP
+sys_remap_file_pages                                                    OK?
+sys_set_tid_address                                                     OK
+compat_sys_timer_create         kernel/compat.c                         CAP
+compat_sys_timer_settime        kernel/compat.c                         CAP
+compat_sys_timer_gettime        kernel/compat.c                         CAP
+sys_timer_getoverrun            kernel/posix-timers.c                   CAP
+sys_timer_delete                kernel/posix-timers.c                   CAP
+compat_sys_clock_settime        kernel/compat.c                         CAP
+compat_sys_clock_gettime        kernel/compat.c                         CAP
+compat_sys_clock_getres         kernel/compat.c                         CAP
+compat_sys_clock_nanosleep      kernel/compat.c                         CAP
+compat_sys_statfs64             fs/compat.c                             CAP
+compat_sys_fstatfs64            fs/compat.c                             CAP
+sys_tgkill                      kernel/signal.c                         CAP
+compat_sys_utimes               fs/compat.c                             CAP+
+sys32_fadvise64_64              arch/x86/ia32/sys_ia32.c                CAP
+quiet_ni_syscall                                                        ---
+sys_mbind                       mm/mempolicy.c                          CAP
+compat_sys_get_mempolicy        mm/mempolicy.c                          CAP
+sys_set_mempolicy               mm/mempolicy.c                          CAP
+compat_sys_mq_open              ipc/compat_mq.c                         CAP
+sys_mq_unlink                   ipc/mqueue.c                            CAP
+compat_sys_mq_timedsend         ipc/compat_mq.c                         CAP
+compat_sys_mq_timedreceive      ipc/compat_mq.c                         CAP
+compat_sys_mq_notify            ipc/compat_mq.c                         CAP
+compat_sys_mq_getsetattr        ipc/compat_mq.c                         CAP
+compat_sys_kexec_load           kernel/kexec.c                          CAP
+compat_sys_waitid               kernel/compat.c                         CAP
+quiet_ni_syscall                                                        ---
+sys_add_key                     security/keys/keyctl.c                  CAP+
+sys_request_key                 security/keys/keyctl.c                  CAP+
+sys_keyctl                      security/keys/keyctl.c                  CAP+
+sys_ioprio_set                  fs/ioprio.c                             CAP+
+sys_ioprio_get                  fs/ioprio.c                             CAP+
+sys_inotify_init                fs/inotify_user.c                       CAP
+sys_inotify_add_watch           fs/inotify_user.c                       CAP
+sys_inotify_rm_watch            fs/inotify_user.c                       CAP
+sys_migrate_pages               mm/mempolicy.c                          CAP
+compat_sys_openat               fs/compat.c                             CAP
+sys_mkdirat                     fs/namei.c                              CAP
+sys_mknodat                     fs/namei.c                              CAP
+sys_fchownat                    fs/open.c                               CAP+
+compat_sys_futimesat            fs/compat.c                             CAP+
+sys32_fstatat                   arch/x86/ia32/sys_ia32.c                CAP
+sys_unlinkat                    fs/namei.c                              CAP
+sys_renameat                    fs/namei.c                              CAP+
+sys_linkat                      fs/namei.c                              CAP
+sys_symlinkat                   fs/namei.c                              CAP+
+sys_readlinkat                  fs/stat.c                               CAP
+sys_fchmodat                    fs/open.c                               CAP
+sys_faccessat                   fs/open.c                               CAP
+compat_sys_pselect6                                                     OK
+compat_sys_ppoll                                                        OK
+sys_unshare                     kernel/fork.c                           CAP
+compat_sys_set_robust_list                                              OK
+compat_sys_get_robust_list                                              OK
+sys_splice                      fs/splice.c                             CAP
+sys32_sync_file_range           arch/x86/ia32/sys_ia32.c                CAP+
+sys_tee                         fs/splice.c                             CAP
+compat_sys_vmsplice             fs/compat.c                             CAP
+compat_sys_move_pages           kernel/compat.c                         CAP+
+sys_getcpu                                                              OK
+sys_epoll_pwait                 fs/eventpoll.c                          CAP
+compat_sys_utimensat            fs/compat.c                             CAP+
+compat_sys_signalfd             fs/compat.c                             CAP
+sys_timerfd_create              fs/timerfd.c                            CAP
+sys_eventfd                     fs/eventfd.c                            CAP
+sys32_fallocate                 arch/x86/ia32/sys_ia32.c                CAP
+compat_sys_timerfd_settime      fs/compat.c                             CAP
+compat_sys_timerfd_gettime      fs/compat.c                             CAP
+
+=== END OF SYSCALL TABLE ===
+*) The line number corresponds to syscall number
+
+Syscall 0:
+sys_restart_syscall             kernel/signal.c                         OK
+
+syscall table is in arch/x86/ia32/ia32entry.S
diff -ruNp linux-2.6.26.1/fs/aio.c linux-2.6.26.1-cher1/fs/aio.c
--- linux-2.6.26.1/fs/aio.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/aio.c	2008-08-05 13:44:37.000000000 +0400
@@ -1266,6 +1266,9 @@ asmlinkage long sys_io_setup(unsigned nr
 	unsigned long ctx;
 	long ret;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	ret = get_user(ctx, ctxp);
 	if (unlikely(ret))
 		goto out;
@@ -1300,7 +1303,12 @@ out:
  */
 asmlinkage long sys_io_destroy(aio_context_t ctx)
 {
-	struct kioctx *ioctx = lookup_ioctx(ctx);
+	struct kioctx *ioctx;
+
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
+        ioctx = lookup_ioctx(ctx);
 	if (likely(NULL != ioctx)) {
 		io_destroy(ioctx);
 		return 0;
@@ -1659,6 +1667,9 @@ asmlinkage long sys_io_submit(aio_contex
 	long ret = 0;
 	int i;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	if (unlikely(nr < 0))
 		return -EINVAL;
 
@@ -1736,6 +1747,9 @@ asmlinkage long sys_io_cancel(aio_contex
 	u32 key;
 	int ret;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
 	ret = get_user(key, &iocb->aio_key);
 	if (unlikely(ret))
 		return -EFAULT;
@@ -1795,9 +1809,13 @@ asmlinkage long sys_io_getevents(aio_con
 				 struct io_event __user *events,
 				 struct timespec __user *timeout)
 {
-	struct kioctx *ioctx = lookup_ioctx(ctx_id);
+	struct kioctx *ioctx;
 	long ret = -EINVAL;
 
+        if (SBOX_IS_RESTRICTED())
+                return -EPERM;
+
+        ioctx = lookup_ioctx(ctx_id);
 	if (likely(ioctx)) {
 		if (likely(min_nr <= nr && min_nr >= 0 && nr >= 0))
 			ret = read_events(ioctx, min_nr, nr, events, timeout);
@@ -1813,3 +1831,9 @@ __initcall(aio_setup);
 EXPORT_SYMBOL(aio_complete);
 EXPORT_SYMBOL(aio_put_req);
 EXPORT_SYMBOL(wait_on_sync_kiocb);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/fs/binfmt_aout.c linux-2.6.26.1-cher1/fs/binfmt_aout.c
--- linux-2.6.26.1/fs/binfmt_aout.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/binfmt_aout.c	2008-08-05 13:44:37.000000000 +0400
@@ -291,8 +291,12 @@ static int load_aout_binary(struct linux
 	rlim = current->signal->rlim[RLIMIT_DATA].rlim_cur;
 	if (rlim >= RLIM_INFINITY)
 		rlim = ~0;
-	if (ex.a_data + ex.a_bss > rlim)
+	if (ex.a_data + ex.a_bss > rlim) {
+                if ((current->sbox_flags & SBOX_MEMLIMITON)) {
+                        current->sbox_flags |= SBOX_WAS_MEMLIMIT;
+                }
 		return -ENOMEM;
+        }
 
 	/* Flush all traces of the currently running executable */
 	retval = flush_old_exec(bprm);
@@ -550,3 +554,9 @@ static void __exit exit_aout_binfmt(void
 core_initcall(init_aout_binfmt);
 module_exit(exit_aout_binfmt);
 MODULE_LICENSE("GPL");
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/fs/binfmt_flat.c linux-2.6.26.1-cher1/fs/binfmt_flat.c
--- linux-2.6.26.1/fs/binfmt_flat.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/binfmt_flat.c	2008-08-05 13:44:37.000000000 +0400
@@ -496,6 +496,9 @@ static int load_flat_file(struct linux_b
 	if (rlim >= RLIM_INFINITY)
 		rlim = ~0;
 	if (data_len + bss_len > rlim) {
+                if ((current->sbox_flags & SBOX_MEMLIMITON)) {
+                        current->sbox_flags |= SBOX_WAS_MEMLIMIT;
+                }
 		ret = -ENOMEM;
 		goto err;
 	}
@@ -938,3 +941,9 @@ static int __init init_flat_binfmt(void)
 core_initcall(init_flat_binfmt);
 
 /****************************************************************************/
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.26.1/fs/buffer.c linux-2.6.26.1-cher1/fs/buffer.c
--- linux-2.6.26.1/fs/buffer.c	2008-08-02 02:58:24.000000000 +0400
+++ linux-2.6.26.1-cher1/fs/buffer.c	2008-08-05 13:44:37.000000000 +0400
@@ -3120,6 +3120,11 @@ asmlinkage long sys_bdflush(int func, lo
 {
 	static int msg_count;
 
+        if (SBOX_IS_RESTRICTED()) {
+                SBOX_SET_SECURITY_ERR();
+                return -EPERM;
+        }
+
 	if (!capable(CAP_SYS_ADMIN))
 		return -EPERM;
 
@@ -3309,3 +3314,9 @@ EXPORT_SYMBOL(mark_buffer_dirty);
 EXPORT_SYMBOL(submit_bh);
 EXPORT_SYMBOL(sync_dirty_buffer);
 EXPORT_SYMBOL(unlock_buffer);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
